// SeeNa vOfR[_ & t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];
unsigned char ram[0x10000];			// Z80

enum {
	SEENASR = 1,
	SEENAMK2,
	SEENAWIDE,
};

D88 disk;
FILE *fp;
int type = 0;

int dload(int _drive, int _trk, int _sec, int _size, int _adr)
{
	int size = 0;
	size = disk.ReadDATA(_trk, _trk>>1, _trk&1, _sec, 0x01, &ram[_adr], _size*0x100);
	if (size != _size*0x100) {
		printf("read error = %04x\n",_adr);
		return 0;
	}
	else return size;
}

int fload(int _drive, int _trk, int _sec, int _size, int _adr)
{
	int trk = (_drive==0)? ram[0xff00+_trk] : _trk;
	int size = 0;
	size = disk.ReadDATA(trk, trk>>1, trk&1, _sec, 0x01, &ram[_adr], _size*0x100);
	if (size != _size*0x100) {
		printf("read error = %04x\n",_adr);
		return 0;
	}
	else return size;
}

bool decode(int _trk, int _adr)
{
	if (fload(0x00, _trk, 1, 0x10, 0x2000) != 0x1000) {
		printf("decode error = %04x\n",_adr);
		return false;
	}
	for (int bc=0; bc<0x1000; bc++) {
		switch (type) {
		case SEENASR:
		case SEENAWIDE:
			ram[0x2000+bc] ^= ram[0x1000+bc];
			break;
		case SEENAMK2:
			ram[0x2000+bc] += ram[0x1000+bc];
			break;
		default:
			fprintf(stderr, ".\n");
			return false;
		}
	}
	memmove(&ram[_adr],&ram[0x2000],0x1000);
	return true;
}

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool msave(char *_fname, int _adr, int _size)
{
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&ram[_adr], 1, _size, fp);
	fclose(fp);
	return true;
}

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i;
	int mus = 0;
	unsigned char drive1 = 0;
	unsigned char drive2 = 0;

	const unsigned char id_sr[]  = "S e e N a   T a k a s h i   s a n   f a n   D E E E S U ";
	const unsigned char id_mk2[] = "S e e N a   T a k a s h i   s a n             ";

	if (argc != 2) {
		fprintf(stderr, "Usage: seenacut [d88file]\n");
		return 1;
	}

	if (!disk.SetFile(argv[1])) {
		fprintf(stderr, "t@CI[vł܂.\n");
		return 2;
	}

	if (disk.GetNumDisk()<2) {
		fprintf(stderr, "System DiskData DiskAC[WgpĂ.\n");
		return 3;
	}

	// Disk B `FbN
	disk.SelectDisk(1);
	disk.SetRecordRange(0x01,0x10);
	dload(0x00, 0x00,0x01,0x01,0xc000);
	drive2 = ram[0xc0ff];

	disk.SelectDisk(0);
	disk.SetRecordRange(0x01,0x10);
	// IPL
	dload(0x00, 0x00,0x01,0x01,0xc000);
	drive1 = ram[0xc0ff];

	if (drive1 != 0x01 || (drive2 != 0x02 && drive2 != 0x03)) {
		fprintf(stderr, "System DiskData DiskAC[WgpĂ.\n");
		return 3;
	}

	// SR/mk2/WIDE SCREEN
	if (!memcmp(&ram[0xc0a0], id_sr, sizeof(id_sr))) {
		if (ram[0xc0f0]==0x13 && ram[0xc0f1] == 0x0f) {
			printf("SeeNa(PC-8801mkIISRp)mF܂.\n");
			type = SEENASR;
		}
		if (ram[0xc0f0]==0x4b && ram[0xc0f1] == 0x06) {
			printf("SeeNa WIDE SCREEN mF܂.\n");
			type = SEENAWIDE;
		}
	}
	else if (!memcmp(&ram[0xc096], id_mk2, sizeof(id_mk2))) {
		printf("SeeNa(PC-8801/mkII)mF܂.\n");
		type = SEENAMK2;

	}
	else {
		fprintf(stderr, "mF̃o[Wł.\n");
		return 4;
	}
	dload(0x00, ram[0xc0f0],ram[0xc0f1],0x01,0xc100);
	dload(0x00, ram[0xc102],0x01,0x10,0x0000);
	// FAT[h
	dload(0x00, ram[0xc0f0],ram[0xc0f1],0x01,0xff00);
	ram[0xffff]=0x00;

	// fR[hp쐬
	switch (type) {
	case SEENASR:
		fload(0x00, 0x00,0x01,0x01,0x1000);
		fload(0x00, 0x01,ram[0xc0f1],0x01,0x1100);
		fload(0x00, 0x02,0x10,0x01,0x1200);
		fload(0x00, 0x00,0x02,0x04,0x1300);
		fload(0x00, 0x00,0x06,0x09,0x1700);
		break;
	case SEENAMK2:
	case SEENAWIDE:
		fload(0x00, 0x00,0x01,0x01,0x1000);
		fload(0x00, 0x01,ram[0xc0f1],0x01,0x1100);
		fload(0x00, 0x02,0x10,0x01,0x1200);
		fload(0x00, 0x26,0x01,0x04,0x1300);
		fload(0x00, 0x02,0x01,0x09,0x1700);
		break;
	default:
		fprintf(stderr, ".\n");
		return 0xff;
	}

	// fR[h
	decode(0x03,0x5800);
	decode(0x04,0x6800);
	decode(0x05,0x7800);
	decode(0x06,0x8800);
	decode(0x07,0x9800);
	decode(0x08,0xa800);
	decode(0x0a,0xbe00);

	// ʏǂݍ
	switch (type) {
	case SEENASR:
	case SEENAMK2:
		disk.SelectDisk(1);
		fload(0x01, 0x0e,0x09,0x04,0xf100);
		break;
	case SEENAWIDE:
		disk.SelectDisk(1);
		fload(0x01, 0x0e,0x0f,0x02,0x4600);
		if (ram[0x4601]!=0x52) {
			disk.SelectDisk(0);
			fload(0x00, 0x4b, 0x01, 0x02, 0x4600);
		}
		disk.SelectDisk(1);
		fload(0x01, 0x0e,0x09,0x04,0xf100);
		break;
	default:
		break;
	}

	disk.SelectDisk(0);
	fload(0x00, 0x09,0x0d,0x01,0x5300);
	fload(0x00, 0x09,0x0c,0x01,0x5700);
	fload(0x00, 0x0e,0x01,0x10,0x2d00);
	fload(0x00, 0x0f,0x01,0x0b,0x3d00);
	fload(0x00, 0x0f,0x0c,0x04,0x4800);
	fload(0x00, 0x0f,0x10,0x01,0xd300);
	fload(0x00, 0x09,0x01,0x01,0xd200);
	fload(0x00, 0x09,0x02,0x01,0xd500);
	fload(0x00, 0x09,0x03,0x01,0x5200);
	fload(0x00, 0x09,0x04,0x05,0x4c00);
	fload(0x00, 0x09,0x09,0x02,0xe600);
	memcpy(&ram[0x5100],&ram[0xe600],0x0080);
	memcpy(&ram[0x5400],&ram[0xe680],0x0140);
	memcpy(&ram[0x5550],&ram[0xe7c0],0x0030);
	fload(0x00, 0x09,0x0b,0x01,0xd400);
	fload(0x00, 0x09,0x0e,0x01,0xbd00);
	fload(0x00, 0x0d,0x09,0x04,0xb900);
	// ======= [_1܂ ===========

//	msave("RAM"    ,0x0000, sizeof(ram));
	msave("PROG"   ,0x5800, 0x6800);

	// ȃf[^؂o 
	// (S10ȁB10Ȃ߂Balance in the Maze88SRłł2Ȃ߂ƊSɓꂾA
	//  mk2,WIDE SCREENł̓AWႢ^Ă)
	for (i=0; i<10; i++) {
		int trk = 0x11 + (i>>1);
		int sec =(i&1)*8+1;
		fload(0x00, trk, sec, 0x08, 0x9000);
		sprintf(fname,"MUS%02d",mus++);
		msave(fname, 0x9000, 0x0800);
	}
	// EhNA
	memset(&ram[0x9000],0x00,0x0800);
	memcpy(&ram[0x9000],&ram[0xf100],0x0280);
	memcpy(&ram[0x9780],&ram[0xf380],0x0080);
	sprintf(fname,"MUS%02d",mus++);
	msave(fname, 0x9000, 0x0800);
	// I[NA
	disk.SelectDisk(1);
	fload(0x01, 0x0c,0x09,0x08,0x9000);
	sprintf(fname,"MUS%02d",mus++);
	msave(fname, 0x9000, 0x0800);

	return 0;

}

